//Retro Fit "Smart" Blinds Project
//ME 608: Intro to Mechatronics
// Santaigo Trejo Lopez

//Settting up the IR Ssen
#define IR_SMALLD_NEC
#include <IRsmallDecoder.h> // include library for IR remote
IRsmallDecoder irsmallDecoder(2);
irSmallD_t irData;
int keyPress; // variable for input from  IR remote

//Setting up the LCD Screen 
#include <LiquidCrystal_I2C.h> //includes library for the LCD Screen
LiquidCrystal_I2C lcd(0x27,16,2); // set the LCD address to 0x27 for a 16 chars and 2 line display

//Setting up the Servo
#include <Servo.h> //include libraray for servo motor
int servopin = 9; //call out pin on board for servo
int i; //counter variable for smooth servo movement
int Servopos; //variable to keep track of servo position 
int Servopostemp; //place holder variable to write servo position
Servo servo;

//Setting up the Photoresistor
const int Lightpin = A1; //call out pin for photoresistor
int Lightval; //keeps tack of photoresistor value

//Setting up variables
const int Temppin = A0; //call out pin for thermistor
float tempVol; 
int Vol;
float DegreesC;
int Temp;
int tune = 3;
int percent; //maps servo movement to % opening of the blinds 

bool run = true; // state variable 

void setup() {
  Serial.begin(9600);

  //Setup for LCD Display
  lcd.init(); // Initialize the LCD
  lcd.backlight();
  lcd.setCursor(0,0);
  lcd.print("Click to Start"); // Initial message

  //Setup for the Servo
    servo.attach(servopin); //attached servo to arduino 

  //Zeroing out the servo (dont know if needed yet)
    writeservo(0);

}

void loop() {
  //waiting for a key press on the remote
  if(irsmallDecoder.dataAvailable(irData)){
    int keyPress = irData.cmd;
    Serial.println(keyPress); //debugging test to see if reading IR remote
    Serial.println("Back to Void loop");
    handleKeyPress(keyPress);
    }
}

void handleKeyPress(int keyPress)
{
  switch (keyPress)
  {
    case 9:
     // This key press would bring the system into its "automated" function
     lcd.clear(); // clears the LCD displays
     // Message on LCD Screen displaying State
     lcd.setCursor(0,0);
     lcd.print("The Blinds set");
     lcd.setCursor(0,1);
     lcd.print("to Automated");

     Serial.println("The Blinds set to Automated"); //debuging message

      while(run == true){
        // Light sensor sutff and map to servo range make comment next to map command to allow users to calibrate their lights to location
        //map total servo movement to percent open
        Lightval = analogRead(Lightpin); //read a value from 0-1023
        Serial.println("Light Value:");
        Serial.println(Lightval);

        Servopos = map(Lightval, 0, 1023, 0, 270); //maps the value of the photoresistor to the correspondsing position of the servo.
        Serial.println("Servo Pos:"); // debugging message
        Serial.println(Servopos);
        i = Servopos; 
        percent = map(Servopos, 0, 270, 0, 100); //mapping the position of the servo to the position of the blinds

        //Write light sensor to servo postion
        writeservo(Servopos);

        //Reading Temperature in Fahrenheit
          Vol = analogRead(Temppin);
          Serial.println(Vol);
          tempVol = (Vol / 1024.0) * 5.0;
          Serial.println(tempVol);
          // convert the voltage to temperature in degrees C
          // the sensor changes 10 mV per degree
          // the datasheet says there's a 500 mV offset
          // ((voltage - 500 mV) times 100)
          DegreesC = (tempVol - 0.5) * 100; // Converts voltage from thermistor to temperature C
          Serial.println(DegreesC);
          Temp = (DegreesC * (1.8)) + 32; //connverts temp from C to F
          Temp = (Temp - tune);
          Serial.print("Temp in F:");
          Serial.println(Temp); // Temp F

        // constantly update temp reading and Position to LCD screen
          lcd.setCursor(0,0);
          lcd.print("Percent Open:");
          lcd.print(percent);
          lcd.setCursor(0,1);
          lcd.print("Temperature:");
          lcd.print(Temp);
          lcd.print("F");
        
        //check for a key press on the remote
          if(irsmallDecoder.dataAvailable(irData)){
          keyPress = irData.cmd;
          Serial.println(keyPress);
          break;
        }
      } 
      break; //Case 9 Break

    case 5:
     // This key press would fully open the blinds
     lcd.clear(); // clears the LCD displays
     // Message on LCD Screen displaying State
     lcd.setCursor(0,0);
     lcd.print("The Blinds set");
     lcd.setCursor(0,1);
     lcd.print("to Open");

     Serial.println("The Blinds have been set to Open"); //debuging message

      //Write a for loop to smoothly open the blinds (check inclass codes)
      //Place the following inside the for loop
        for (i; i < 270; i++){ // for to smoothly open the blinds
          writeservo(i); // updating the servo's postion

          delay(10); // delay bewteen movement signals (change as needed)
          
          //check for a key press on the remote
            if(irsmallDecoder.dataAvailable(irData)){
            keyPress = irData.cmd;
            Serial.println(keyPress); 
            }
        }

        lcd.clear(); // clears the LCD displays

      while(run == true){
        // copy code that constantly update temp reading and light levels to LCD screen here

        //Reading Temperature in Fahrenheit
          Vol = analogRead(Temppin);
          Serial.println(Vol);
          tempVol = (Vol / 1024.0) * 5.0;
          Serial.println(tempVol);
          // convert the voltage to temperature in degrees C
          // the sensor changes 10 mV per degree
          // the datasheet says there's a 500 mV offset
          // ((voltage - 500 mV) times 100)
          DegreesC = (tempVol - 0.5) * 100; // Converts voltage from thermistor to temperature C
          Serial.println(DegreesC);
          Temp = (DegreesC * (1.8)) + 32; //connverts temp from C to F
          Temp = (Temp - tune);
          Serial.print("Temp in F:");
          Serial.println(Temp); // Temp F

        // constantly update temp reading and Position to LCD screen
          lcd.setCursor(0,0);
          lcd.print("Blinds Open");
          lcd.setCursor(0,1);
          lcd.print("Temperature:");
          lcd.print(Temp);
          lcd.print("F");

         //check for a key press on the remote
          if(irsmallDecoder.dataAvailable(irData)){
          keyPress = irData.cmd;
          Serial.println(keyPress); 
          break;
        }
      }  

     break; // Case 5 Break

    case 13:
     // This key press would fully close the blinds
     lcd.clear(); // clears the LCD displays
     // Message on LCD Screen displaying State
     lcd.setCursor(0,0);
     lcd.print("The Blinds set");
     lcd.setCursor(0,1);
     lcd.print("to Closed");

     Serial.println("The Blinds have been set to Closed"); //debuging message

      //Write a for loop to smoothly close the blinds (check inclass codes)
      //Place the following inside the for loop
      for (i; i > 0; i--){ // for to smoothly open the blinds
          writeservo(i); // updating the servo's postion

          delay(10); // delay bewteen movement signals (change as needed)

          //check for a key press on the remote
            if(irsmallDecoder.dataAvailable(irData)){
            keyPress = irData.cmd;
            Serial.println(keyPress);
            break;
            }

        }

        lcd.clear(); // clears the LCD displays

      while(run == true){
        // copy code that constantly update temp reading and light levels to LCD screen here
          //Reading Temperature in Fahrenheit
          Vol = analogRead(Temppin);
          Serial.println(Vol);
          tempVol = (Vol / 1024.0) * 5.0;
          Serial.println(tempVol);
          // convert the voltage to temperature in degrees C
          // the sensor changes 10 mV per degree
          // the datasheet says there's a 500 mV offset
          // ((voltage - 500 mV) times 100)
          DegreesC = (tempVol - 0.5) * 100; // Converts voltage from thermistor to temperature C
          Serial.println(DegreesC);
          Temp = (DegreesC * (1.8)) + 32; //connverts temp from C to F
          Temp = (Temp - tune);
          Serial.print("Temp in F:");
          Serial.println(Temp); // Temp F

        // constantly update temp reading and Position to LCD screen
          lcd.setCursor(0,0);
          lcd.print("Blinds Closed");
          lcd.setCursor(0,1);
          lcd.print("Temperature:");
          lcd.print(Temp);
          lcd.print("F");

         //check for a key press on the remote
          if(irsmallDecoder.dataAvailable(irData)){
          keyPress = irData.cmd;
          Serial.println(keyPress); 
          break;
        }
      }  

     break; // Case 13 Break
  }
}

//Custom Function to position the servo
void writeservo(int mapval){
  Servopostemp = map(mapval, 0, 270, 500, 2500); //maps the servo degrees of movement in to the pulse width signals for the servo
  servo.writeMicroseconds(Servopostemp);

}